clear all
close all
format long
% process the data taken with the network analyzer

% The user must specify the TE mode numbers of each resonance used and list 
% any resonances that are not measured for some of the pressures along with
% appropriate listing of pressure/file name extensions in line 13.  The
% length of each string must be the same, hence the added spaces at the end
% of the names.  A unique file name should be chosen for line 64.

W=0;
P=deblank(['30mbar_pure          ';'120mbar_pure         ';'halfbar_1percent     ';'1bar_1percent        ';'2bars_1percent       ';'4bars_1percent       ';'6bars_1percent       ';'8bars_1percent       ';'12bars_1percent      ';'4bars_quarterpercent '; '8bars_quarterpercent '; '12bars_quarterpercent'; '8bars_16thpercent    '; '12bars_16thpercent   ']);

%filetag='_pure';
filetag='';
if W==1
load processed_data_withrefrac_bigres

else
    disp('running...')
TEmodes=[0 1 1;
0 1 2;
0 1 3;
0 1 4;
0 2 2;
0 2 3;
0 1 5;
0 2 4;
0 1 6;
0 3 3;
0 2 6;
2 2 7;
0 3 6;
0 2 8;
0 1 9;
0 3 8;
0 2 10;
0 3 11;
1 3 9];

for i=1:length(P(:,1))
i   % display incrementer for tracking progress of data processing
for R=1:19
    if (R==19) && (i==1||i==2||i==7||i==8||i==9)    % resonance not measured for these pressures
%   elseif (R==25 || R==26 || R==28 || R==29 || R==31 || R==32) && Pr==3
    else
        [Absorption(R,i,:) sigma_diel(R,i) sigma_n(R,i) sigma_trans(R,i) nh3PeakFa(R,i) nh3Asymma(R,i) ArAsymma(R,i) Pressure(R,i) P_2sigma(R,i) Temperature(R,i) T_2sigma(R,i) Nmeasured(R,i) Nmeasured_2sigma(R,i) NmeasuredAr(R,i) NmeasuredAr_2sigma(R,i) TAr(R,i) PAr(R,i)]=Acalc(R,P(i,:),0,filetag,0,0,0,21,1,4,TEmodes);
        Absorption_2Sigma(R,i)=sqrt((abs(Absorption(R,i,2)-Absorption(R,i,3)))^2+sigma_diel(R,i)^2+sigma_n(R,i)^2+sigma_trans(R,i)^2);
        % set up datamatrix for export to Excel file
        datamatrix((i-1)*19+R,:)=[nh3PeakFa(R,i) TEmodes(R,1) TEmodes(R,2) TEmodes(R,3) Absorption(R,i) Absorption_2Sigma(R,i) Nmeasured(R,i) Nmeasured_2sigma(R,i) Pressure(R,i) P_2sigma(R,i) Temperature(R,i) T_2sigma(R,i) sigma_diel(R,i) sigma_trans(R,i) sigma_n(R,i) abs((Absorption(R,i,2)-Absorption(R,i,3))) NmeasuredAr(R,i) NmeasuredAr_2sigma(R,i) TAr(R,i) PAr(R,i)];

    end
end
        

% display processed opacity data
semilogy (nh3PeakFa(:,i)/1e9, Absorption(:,i),'bx')
hold on
errorbar(nh3PeakFa(:,i)/1e9, Absorption(:,i), Absorption_2Sigma(:,i),'bx')
end

% choose a file name to save data set to
save processed_data_ALL_bigres_S21_010708_450_FINAL
end
