clear all
close all
format long
% process the data taken with the network analyzer

% The user must specify the TE mode numbers of each resonance used and list 
% any resonances that are not measured for some of the pressures along with
% appropriate listing of pressure/file name extensions in line 13.  The
% length of each string must be the same, hence the added spaces at the end
% of the names.  A unique file name should be chosen for line 64.

P=deblank(['30mbar_pure          ';'120mbar_pure         ';'halfbar_1percent     ';'1bar_1percent        ';'2bars_1percent       ';'4bars_1percent       ';'6bars_1percent       ';'8bars_1percent       ';'12bars_1percent      ';'4bars_quarterpercent '; '8bars_quarterpercent '; '12bars_quarterpercent'; '8bars_16thpercent    '; '12bars_16thpercent   ']);
%P=0.25;
filetag='';
%filetag='_pure';

    disp('running...')
TEmodes=[zeros(59,3);
0 1 3;
0 1 4;
0 2 2;
0 2 3;
0 1 5;
0 2 4;
2 3 2;
0 3 3;
0 3 4;
0 3 5;
0 5 6];
% r=1.362344e-22*1.01325;
% NH3mr=[0.0120 0.0107 0.01 0.00932 0.0087 0.0084 0.0083];
% Hemr=.136*(1-NH3mr);
% H2mr=.864*(1-NH3mr);

for i=1:length(P(:,1))
i   % display incrementer for tracking progress of data processing
for R=60:70
    if R==71 % resonance not measured for these pressures
    elseif R==69 && (i==2) % resonance not measured for this pressure
    %elseif (R==65||R==66||R==67) && (i<5||i==7)
    %elseif R==68 && (i~=5) 
    %elseif R==70 && (i==4)
    %elseif R==80 && (Pr==0.5||Pr==0.125) 
    %elseif R==81 && (Pr==0.5||Pr==0.125)
    else
        [Absorption(R,i,:) sigma_diel(R,i) sigma_n(R,i) sigma_trans(R,i) nh3PeakFa(R,i) nh3Asymma(R,i) ArAsymma(R,i) Pressure(R,i) P_2sigma(R,i) Temperature(R,i) T_2sigma(R,i) Nmeasured(R,i) Nmeasured_2sigma(R,i) NmeasuredAr(R,i) NmeasuredAr_2sigma(R,i) TAr(R,i) PAr(R,i)]=Acalc(R,P(i,:),1,filetag,0,0,0,0,2,7,TEmodes);
        Absorption_2Sigma(R,i)=sqrt((abs(Absorption(R,i,2)-Absorption(R,i,3)))^2+sigma_diel(R,i)^2+sigma_n(R,i)^2+sigma_trans(R,i)^2);
        % set up datamatrix for export to Excel file
        datamatrix((i-1)*11+R-59,:)=[nh3PeakFa(R,i) TEmodes(R,1) TEmodes(R,2) TEmodes(R,3) Absorption(R,i) Absorption_2Sigma(R,i) Nmeasured(R,i) Nmeasured_2sigma(R,i) Pressure(R,i) P_2sigma(R,i) Temperature(R,i) T_2sigma(R,i) sigma_diel(R,i) sigma_trans(R,i) sigma_n(R,i) abs((Absorption(R,i,2)-Absorption(R,i,3))) NmeasuredAr(R,i) NmeasuredAr_2sigma(R,i) TAr(R,i) PAr(R,i)];
    end

end

figure(1)
semilogy (nh3PeakFa(:,i)/1e9, Absorption(:,i),'kx')
hold on
errorbar(nh3PeakFa(:,i)/1e9, Absorption(:,i), Absorption_2Sigma(:,i),'kx')
end

% choose a file name to save data set to
save processed_data_ALL_smallres_010708_450_FINAL
