function [transa transe]=trancalNA(B,numswp,freq,PeakFa)
% function for calculating the transmissivity amplitudes for measurements
% using the network analyzer

% this smooths the data and finds returns the amplitude at the peak
% frequency of the resonance used and its uncertainty

Boriginal=B;
for s=1:numswp
[pp, p]=csaps(freq,B(:,s));
[pp, p2]=csaps(freq,B(:,s),p*1e-7); % enhance default smoothing by a factor of 10^7
Tran(s)=ppval(pp,PeakFa);

end

transa=mean(Tran);
transe=std(Tran);

B=Boriginal;
