function [transa transe]=trancalsync(C,numswp,freq,PeakFa)
% function for calculating the transmissivity amplitudes for measurements
% using the synchronized spectrum analyzer

% this smooths the data and finds returns the amplitude at the peak
% frequency of the resonance used and its uncertainty
Coriginal=C;

for s=1:numswp
    [pp, p]=csaps(freq,C(:,s));
    [pp, p2]=csaps(freq,C(:,s),p*1e-3); % enhance default smoothing by a factor of 1000
    Tran(s)=ppval(pp,PeakFa);
end

transa=mean(Tran);
transe=std(Tran);

C=Coriginal;