function [Tran]=transdeconvolve(Rstr,ptag,filetag,device,sync,old)
% code used for deconvolving transmissivities for each of the measurement
% devices/configurations

% Returns a vector of transmissivity values for the length of the measured frequency span

filenm=strcat(Rstr,'_trans2_',ptag,filetag);

if device==0
    load(filenm,'S21', 'numswp','faxis')
    S21=transmoothNA(S21,faxis,numswp);
    Tran=mean(S21,2);
    clear S21
elseif device==1 && sync==0 && old==1
    load(filenm,'B','numswp','freq')
    B=transmooth(B, numswp, freq);
    Tran=mean(B,2);
    clear B
elseif device==1 && sync==0 && old==0
    load(filenm,'B','numswp2','freq')
    B=transmooth(B, numswp2, freq);
    Tran=mean(B,2);
    clear B
elseif device==1 && sync==1
    load(filenm,'C','numswp','freq')
    C=transmoothsync(C, numswp, freq);
    Tran=mean(C,2);
    clear C
elseif device==2
    load(filenm,'S21','numswp','faxis')
    S21=transmoothNA(S21,faxis,numswp);
    Tran=mean(S21,2);
    clear S21    
end

