function [TranSmooth]=transmooth(B,numswp,freq)
% code that smooths the transmissivity values measured by the
% unsynchronized spectrum analyzer for use in deconvolution

Boriginal=B;
tol=1;
fix1=zeros(1,numswp);
fix2=zeros(1,numswp);
fix3=zeros(1,numswp);
nofa=0;
nofb=0;
maxfixup=50;
maxfixdown=10;
uptol=0.001;
downtol=0.005;

for s=1:numswp
    n=0;
    clear freqo2 Bo2
    tol=1;
    diff=zeros(601,numswp);
    bottom=min(B(:,s));
    i=1;
    
while tol>uptol 
    avg(1)=(B(2,s)+B(3,s)+B(4,s)+B(5,s)+B(6,s))/5;
    avg(2)=(B(1,s)+B(3,s)+B(4,s)+B(5,s)+B(6,s)+B(7,s))/6;
    avg(3)=(B(1,s)+B(2,s)+B(4,s)+B(5,s)+B(6,s)+B(7,s)+B(8,s))/7;
    avg(4)=(B(1,s)+B(2,s)+B(3,s)+B(5,s)+B(6,s)+B(7,s)+B(8,s)+B(9,s))/8;
    avg(5)=(B(1,s)+B(2,s)+B(3,s)+B(4,s)+B(6,s)+B(7,s)+B(8,s)+B(9,s)+B(10,s))/9;
    for k=6:596
        avg(k)=(B(k-5,s)+B(k-4,s)+B(k-3,s)+B(k-2,s)+B(k-1,s)+B(k+1,s)+B(k+2,s)+B(k+3,s)+B(k+4,s)+B(k+5,s))/10;
    end
    avg(601)=(B(596,s)+B(597,s)+B(598,s)+B(599,s)+B(600,s))/5;
    avg(600)=(B(595,s)+B(596,s)+B(597,s)+B(598,s)+B(599,s)+B(601,s))/6;
    avg(599)=(B(594,s)+B(595,s)+B(596,s)+B(597,s)+B(598,s)+B(600,s)+B(601,s))/7;
    avg(598)=(B(593,s)+B(594,s)+B(595,s)+B(596,s)+B(597,s)+B(599,s)+B(600,s)+B(601,s))/8;
    avg(597)=(B(592,s)+B(593,s)+B(594,s)+B(595,s)+B(596,s)+B(598,s)+B(599,s)+B(600,s)+B(601,s))/9;
    for m=1:601
        if B(m,s)< avg(m)
            diff(m,s)=abs(-avg(m)+B(m,s));
            B(m,s)=avg(m);
        end
    end
    tol=max(diff(:,s));    
    if fix1(s)==maxfixup
        tol=0;
    else
        fix1(s)=fix1(s)+1;
    end
end
B1st(:,s)=B(:,s);
tol=1;
diff(:,s)=zeros(601,1);
while tol>downtol
    avg(1)=(B(2,s)+B(3,s))/2;
    avg(2)=(B(1,s)+B(3,s)+B(4,s))/3;
    for k=3:599
        avg(k)=(B(k-2,s)+B(k-1,s)+B(k+1,s)+B(k+2,s))/4;
    end
    avg(601)=(B(599,s)+B(600,s))/2;
    avg(600)=(B(598,s)+B(599,s)+B(601,s))/3;
    for m=1:601
        if B(m,s)> avg(m)
            diff(m,s)=abs(avg(m)-B(m,s));
            B(m,s)=avg(m);
        end
    end
    tol=max(diff(:,s));
    if fix2(s)==maxfixdown
        tol=0;
    else
        fix2(s)=fix2(s)+1;
    end
end
for q=1:601
    if Boriginal(q,s)~=bottom && (B(q,s)-Boriginal(q,s))<0.1
        n=n+1;
        B3(n)=B(q,s)-Boriginal(q,s);

        Bo(n,s)=Boriginal(q,s);
        Bo2(n)=Boriginal(q,s);
        freqo(n,s)=freq(q);
        freqo2(n)=freq(q);

    end
end
[pp, p]=csaps(freqo2,Bo2);
[pp, p2]=csaps(freqo2,Bo2,p*1e-5);  % enhance default smoothing by a factor of 10^5
Po(:,s)=ppval(pp,freq);
end

TranSmooth=Po;
